Tonyu.klass.define({
  fullName: 'user.Ball',
  shortName: 'Ball',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: {
    main :function _trc_Ball_main() {
      "use strict";
      var _this=this;
      
      
    },
    fiber$main :function _trc_Ball_f_main(_thread) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      
      
      
      _thread.retVal=_this;return;
    },
    onAppear :function _trc_Ball_onAppear() {
      "use strict";
      var _this=this;
      
      //$LASTPOS=1000029;//user.Ball:29
      _this.shade=new Tonyu.classes.kernel.ActorSprite({x: _this.x,y: _this.y,p: Tonyu.globals.$pshade});
    },
    fiber$onAppear :function _trc_Ball_f_onAppear(_thread) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      
      //$LASTPOS=1000029;//user.Ball:29
      _this.shade=new Tonyu.classes.kernel.ActorSprite({x: _this.x,y: _this.y,p: Tonyu.globals.$pshade});
      
      _thread.retVal=_this;return;
    },
    draw :function _trc_Ball_draw(ctx) {
      "use strict";
      var _this=this;
      
      //$LASTPOS=1000087;//user.Ball:87
      Tonyu.classes.kernel.Actor.prototype.draw.apply( _this, [ctx]);
      //$LASTPOS=1000108;//user.Ball:108
      _this.shade.x=_this.x;
      //$LASTPOS=1000123;//user.Ball:123
      _this.shade.y=_this.y;
      //$LASTPOS=1000138;//user.Ball:138
      _this.shade.draw(ctx);
    },
    chainable :function _trc_Ball_chainable(b) {
      "use strict";
      var _this=this;
      
      return _this.col===b.col||_this.letter===b.letter||_this.col===b.letter||_this.letter===b.col;
    },
    fiber$chainable :function _trc_Ball_f_chainable(_thread,b) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      
      _thread.retVal=_this.col===b.col||_this.letter===b.letter||_this.col===b.letter||_this.letter===b.col;return;
      
      
      _thread.retVal=_this;return;
    },
    __getter__basep :function _trc_Ball___getter__basep() {
      "use strict";
      var _this=this;
      
      return _this.p-Tonyu.globals.$pat_iroball;
    },
    __getter__col :function _trc_Ball___getter__col() {
      "use strict";
      var _this=this;
      
      return _this.basep%5;
    },
    __getter__letter :function _trc_Ball___getter__letter() {
      "use strict";
      var _this=this;
      
      return _this.floor(_this.basep/5);
    },
    __dummy: false
  },
  decls: {"methods":{"main":{"nowait":false},"onAppear":{"nowait":false},"draw":{"nowait":true},"chainable":{"nowait":false},"__getter__basep":{"nowait":true},"__getter__col":{"nowait":true},"__getter__letter":{"nowait":true}},"fields":{"shade":{}}}
});
Tonyu.klass.define({
  fullName: 'user.Chain',
  shortName: 'Chain',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: {
    main :function _trc_Chain_main() {
      "use strict";
      var _this=this;
      var _it_92;
      
      
      //$LASTPOS=2000011;//user.Chain:11
      _this.path = [{gx: _this.gx,gy: _this.gy,b: Tonyu.globals.$pzScreen.getSBall(_this.gx,_this.gy)}];
      
      //$LASTPOS=2000059;//user.Chain:59
      while (Tonyu.globals.$touches[0].touched) {
        Tonyu.checkLoop();
        //$LASTPOS=2000093;//user.Chain:93
        _this.g = Tonyu.globals.$pzScreen.grid(Tonyu.globals.$touches[0]);
        
        //$LASTPOS=2000132;//user.Chain:132
        Tonyu.globals.$pzScreen.zoom(Tonyu.globals.$pzScreen.toLocal(Tonyu.globals.$touches[0]));
        //$LASTPOS=2000184;//user.Chain:184
        if (_this.abs(_this.g.gx-_this.gx)+_this.abs(_this.g.gy-_this.gy)==1) {
          //$LASTPOS=2000228;//user.Chain:228
          _this.b = Tonyu.globals.$pzScreen.getSBall(_this.g.gx,_this.g.gy);
          
          //$LASTPOS=2000273;//user.Chain:273
          _this.lastb = _this.path[_this.path.length-1].b;
          
          //$LASTPOS=2000314;//user.Chain:314
          if (_this.b&&! _this.b.inchain) {
            //$LASTPOS=2000349;//user.Chain:349
            if (_this.lastb.chainable(_this.b)) {
              //$LASTPOS=2000391;//user.Chain:391
              _this.gx=_this.g.gx;
              //$LASTPOS=2000416;//user.Chain:416
              _this.gy=_this.g.gy;
              //$LASTPOS=2000441;//user.Chain:441
              _this.b.inchain=true;
              //$LASTPOS=2000570;//user.Chain:570
              _this.path.push({gx: _this.gx,gy: _this.gy,b: _this.b});
              
            } else {
              //$LASTPOS=2000627;//user.Chain:627
              _this.print("MISS");
              break;
              
              
            }
            
          }
          
        }
        //$LASTPOS=2000699;//user.Chain:699
        _this.update();
        
      }
      //$LASTPOS=2000711;//user.Chain:711
      _it_92=Tonyu.iterator(_this.path,1);
      while(_it_92.next()) {
        _this.p=_it_92[0];
        
        //$LASTPOS=2000737;//user.Chain:737
        _this.p.b.die();
        //$LASTPOS=2000752;//user.Chain:752
        Tonyu.globals.$pzScreen.rm(_this.p.gx,_this.p.gy);
        
      }
      //$LASTPOS=2000779;//user.Chain:779
      Tonyu.globals.$pzScreen.fill();
      //$LASTPOS=2000813;//user.Chain:813
      Tonyu.globals.$pzScreen.zoom();
      //$LASTPOS=2000831;//user.Chain:831
      _this.die();
    },
    fiber$main :function _trc_Chain_f_main(_thread) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      var _it_92;
      
      
      //$LASTPOS=2000011;//user.Chain:11
      _this.path = [{gx: _this.gx,gy: _this.gy,b: Tonyu.globals.$pzScreen.getSBall(_this.gx,_this.gy)}];
      
      
      _thread.enter(function _trc_Chain_ent_main(_thread) {
        if (_thread.lastEx) __pc=_thread.catchPC;
        for(var __cnt=100 ; __cnt--;) {
          switch (__pc) {
          case 0:
            //$LASTPOS=2000059;//user.Chain:59
          case 1:
            if (!(Tonyu.globals.$touches[0].touched)) { __pc=7     ; break; }
            //$LASTPOS=2000093;//user.Chain:93
            _this.g = Tonyu.globals.$pzScreen.grid(Tonyu.globals.$touches[0]);
            
            //$LASTPOS=2000132;//user.Chain:132
            Tonyu.globals.$pzScreen.zoom(Tonyu.globals.$pzScreen.toLocal(Tonyu.globals.$touches[0]));
            //$LASTPOS=2000184;//user.Chain:184
            if (!(_this.abs(_this.g.gx-_this.gx)+_this.abs(_this.g.gy-_this.gy)==1)) { __pc=5     ; break; }
            //$LASTPOS=2000228;//user.Chain:228
            _this.b = Tonyu.globals.$pzScreen.getSBall(_this.g.gx,_this.g.gy);
            
            //$LASTPOS=2000273;//user.Chain:273
            _this.lastb = _this.path[_this.path.length-1].b;
            
            //$LASTPOS=2000314;//user.Chain:314
            if (!(_this.b&&! _this.b.inchain)) { __pc=4     ; break; }
            //$LASTPOS=2000349;//user.Chain:349
            if (!(_this.lastb.chainable(_this.b))) { __pc=2     ; break; }
            {
              //$LASTPOS=2000391;//user.Chain:391
              _this.gx=_this.g.gx;
              //$LASTPOS=2000416;//user.Chain:416
              _this.gy=_this.g.gy;
              //$LASTPOS=2000441;//user.Chain:441
              _this.b.inchain=true;
              //$LASTPOS=2000570;//user.Chain:570
              _this.path.push({gx: _this.gx,gy: _this.gy,b: _this.b});
            }
            __pc=3     ;break;
          case 2     :
            //$LASTPOS=2000627;//user.Chain:627
            _this.print("MISS");
            __pc=7     ; break;
            
          case 3     :
            
          case 4     :
            
          case 5     :
            
            //$LASTPOS=2000699;//user.Chain:699
            _this.fiber$update(_thread);
            __pc=6;return;
          case 6:
            
            __pc=1;break;
          case 7     :
            
            //$LASTPOS=2000711;//user.Chain:711
            _it_92=Tonyu.iterator(_this.path,1);
            while(_it_92.next()) {
              _this.p=_it_92[0];
              
              //$LASTPOS=2000737;//user.Chain:737
              _this.p.b.die();
              //$LASTPOS=2000752;//user.Chain:752
              Tonyu.globals.$pzScreen.rm(_this.p.gx,_this.p.gy);
              
            }
            //$LASTPOS=2000779;//user.Chain:779
            Tonyu.globals.$pzScreen.fill();
            //$LASTPOS=2000813;//user.Chain:813
            Tonyu.globals.$pzScreen.zoom();
            //$LASTPOS=2000831;//user.Chain:831
            _this.die();
            _thread.exit(_this);return;
          }
        }
      });
    },
    draw :function _trc_Chain_draw(ctx) {
      "use strict";
      var _this=this;
      var t;
      var c;
      var p;
      var _it_94;
      var l;
      
      //$LASTPOS=2000856;//user.Chain:856
      t = new Tonyu.classes.user.Turtle(ctx,_this.path[0].gx*32+16,_this.path[0].gy*32+16);
      
      //$LASTPOS=2000917;//user.Chain:917
      c = new Tonyu.classes.kernel.Color({h: Tonyu.globals.$frameCount,s: 1,l: 0.5});
      
      //$LASTPOS=2000964;//user.Chain:964
      t.fillStyle=c;
      //$LASTPOS=2000983;//user.Chain:983
      t.strokeStyle=c;
      //$LASTPOS=2001004;//user.Chain:1004
      t.lineWidth=3;
      //$LASTPOS=2001051;//user.Chain:1051
      _it_94=Tonyu.iterator(_this.path,1);
      while(_it_94.next()) {
        p=_it_94[0];
        
        //$LASTPOS=2001081;//user.Chain:1081
        t.lineTo(p.gx*32+16,p.gy*32+16);
        //$LASTPOS=2001122;//user.Chain:1122
        t.circle(5);
        
      }
      //$LASTPOS=2001189;//user.Chain:1189
      l = Tonyu.globals.$pzScreen.toLocal(Tonyu.globals.$touches[0]);
      
      //$LASTPOS=2001231;//user.Chain:1231
      t.lineTo(l.x,l.y);
    },
    __dummy: false
  },
  decls: {"methods":{"main":{"nowait":false},"draw":{"nowait":true}},"fields":{"gx":{},"gy":{},"path":{},"g":{},"b":{},"lastb":{},"p":{}}}
});
Tonyu.klass.define({
  fullName: 'user.ColorSprite',
  shortName: 'ColorSprite',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Panel,
  includes: [],
  methods: {
    main :function _trc_ColorSprite_main() {
      "use strict";
      var _this=this;
      
    },
    fiber$main :function _trc_ColorSprite_f_main(_thread) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      
      
      _thread.retVal=_this;return;
    },
    draw :function _trc_ColorSprite_draw(ctx) {
      "use strict";
      var _this=this;
      var i;
      
      //$LASTPOS=3000033;//user.ColorSprite:33
      i = Tonyu.globals.$imageList[_this.p];
      
      //$LASTPOS=3000058;//user.ColorSprite:58
      if (i) {
        //$LASTPOS=3000074;//user.ColorSprite:74
        if (i.width!=_this.width||i.height!=_this.height) {
          //$LASTPOS=3000128;//user.ColorSprite:128
          _this.resize(i.width,i.height);
          
        }
        //$LASTPOS=3000173;//user.ColorSprite:173
        _this.clearRect();
        //$LASTPOS=3000194;//user.ColorSprite:194
        _this.drawSprite(_this.width/2,_this.height/2,_this.p);
        //$LASTPOS=3000234;//user.ColorSprite:234
        _this.replaceColor(_this.fillStyle);
        
      }
      //$LASTPOS=3000269;//user.ColorSprite:269
      Tonyu.classes.kernel.Panel.prototype.draw.apply( _this, [ctx]);
    },
    __dummy: false
  },
  decls: {"methods":{"main":{"nowait":false},"draw":{"nowait":true}},"fields":{}}
});
Tonyu.klass.define({
  fullName: 'user.DBall',
  shortName: 'DBall',
  namespace: 'user',
  superclass: Tonyu.classes.user.Ball,
  includes: [],
  methods: {
    main :function _trc_DBall_main() {
      "use strict";
      var _this=this;
      
      
      //$LASTPOS=4000024;//user.DBall:24
      _this.drop();
    },
    fiber$main :function _trc_DBall_f_main(_thread) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      
      
      
      _thread.enter(function _trc_DBall_ent_main(_thread) {
        if (_thread.lastEx) __pc=_thread.catchPC;
        for(var __cnt=100 ; __cnt--;) {
          switch (__pc) {
          case 0:
            //$LASTPOS=4000024;//user.DBall:24
            _this.fiber$drop(_thread);
            __pc=1;return;
          case 1:
            
            _thread.exit(_this);return;
          }
        }
      });
    },
    drop :function _trc_DBall_drop() {
      "use strict";
      var _this=this;
      var gx;
      var gy;
      var b;
      
      
      //$LASTPOS=4000061;//user.DBall:61
      while (true) {
        Tonyu.checkLoop();
        //$LASTPOS=4000083;//user.DBall:83
        _this.y+=8;
        //$LASTPOS=4000115;//user.DBall:115
        gx=_this.floor(_this.x/32);
        //$LASTPOS=4000139;//user.DBall:139
        gy=_this.floor(_this.y/32);
        //$LASTPOS=4000163;//user.DBall:163
        if (gy==Tonyu.globals.$r-1||_this.scr.getSBall(gx,gy+1)!=null) {
          break;
          
          
        }
        //$LASTPOS=4000370;//user.DBall:370
        _this.update();
        
      }
      //$LASTPOS=4000417;//user.DBall:417
      while (_this.y<gy*32+16) {
        Tonyu.checkLoop();
        //$LASTPOS=4000445;//user.DBall:445
        _this.y+=8;
        //$LASTPOS=4000459;//user.DBall:459
        _this.update();
        
      }
      //$LASTPOS=4000479;//user.DBall:479
      _this.y=gy*32+16;
      //$LASTPOS=4000515;//user.DBall:515
      b = _this.scr.genSBall(gx,gy,_this.p);
      
      //$LASTPOS=4000553;//user.DBall:553
      _this.die();
    },
    fiber$drop :function _trc_DBall_f_drop(_thread) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      var gx;
      var gy;
      var b;
      
      
      
      _thread.enter(function _trc_DBall_ent_drop(_thread) {
        if (_thread.lastEx) __pc=_thread.catchPC;
        for(var __cnt=100 ; __cnt--;) {
          switch (__pc) {
          case 0:
            //$LASTPOS=4000061;//user.DBall:61
          case 1:
            //$LASTPOS=4000083;//user.DBall:83
            _this.y+=8;
            //$LASTPOS=4000115;//user.DBall:115
            gx=_this.floor(_this.x/32);
            //$LASTPOS=4000139;//user.DBall:139
            gy=_this.floor(_this.y/32);
            //$LASTPOS=4000163;//user.DBall:163
            if (!(gy==Tonyu.globals.$r-1||_this.scr.getSBall(gx,gy+1)!=null)) { __pc=2     ; break; }
            __pc=4     ; break;
            
          case 2     :
            
            //$LASTPOS=4000370;//user.DBall:370
            _this.fiber$update(_thread);
            __pc=3;return;
          case 3:
            
            __pc=1;break;
          case 4     :
            
            //$LASTPOS=4000417;//user.DBall:417
          case 5:
            if (!(_this.y<gy*32+16)) { __pc=7     ; break; }
            //$LASTPOS=4000445;//user.DBall:445
            _this.y+=8;
            //$LASTPOS=4000459;//user.DBall:459
            _this.fiber$update(_thread);
            __pc=6;return;
          case 6:
            
            __pc=5;break;
          case 7     :
            
            //$LASTPOS=4000479;//user.DBall:479
            _this.y=gy*32+16;
            //$LASTPOS=4000515;//user.DBall:515
            b = _this.scr.genSBall(gx,gy,_this.p);
            
            //$LASTPOS=4000553;//user.DBall:553
            _this.die();
            _thread.exit(_this);return;
          }
        }
      });
    },
    __dummy: false
  },
  decls: {"methods":{"main":{"nowait":false},"drop":{"nowait":false}},"fields":{"scr":{}}}
});
Tonyu.klass.define({
  fullName: 'user.Enemy',
  shortName: 'Enemy',
  namespace: 'user',
  superclass: Tonyu.classes.user.ColorSprite,
  includes: [],
  methods: {
    main :function _trc_Enemy_main() {
      "use strict";
      var _this=this;
      
      //$LASTPOS=5000022;//user.Enemy:22
      _this.scaleX=2;
    },
    fiber$main :function _trc_Enemy_f_main(_thread) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      
      //$LASTPOS=5000022;//user.Enemy:22
      _this.scaleX=2;
      
      _thread.retVal=_this;return;
    },
    __dummy: false
  },
  decls: {"methods":{"main":{"nowait":false}},"fields":{}}
});
Tonyu.klass.define({
  fullName: 'user.Main',
  shortName: 'Main',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: {
    main :function _trc_Main_main() {
      "use strict";
      var _this=this;
      
      
      //$LASTPOS=6000017;//user.Main:17
      Tonyu.globals.$r=5;
      //$LASTPOS=6000022;//user.Main:22
      Tonyu.globals.$c=6;
      //$LASTPOS=6000028;//user.Main:28
      Tonyu.globals.$Screen.setBGColor("black");
      //$LASTPOS=6000057;//user.Main:57
      Tonyu.globals.$Screen.resize(Tonyu.globals.$c*32,Tonyu.globals.$r*64);
      //$LASTPOS=6000086;//user.Main:86
      _this.m=new Tonyu.classes.user.MakePat;
      //$LASTPOS=6000101;//user.Main:101
      _this.waitEvent(_this.m,"die");
      //$LASTPOS=6000121;//user.Main:121
      Tonyu.globals.$e=new Tonyu.classes.user.Enemy({x: 100,y: 100,p: Tonyu.globals.$pat_enemy1,fillStyle: "#ff0"});
      //$LASTPOS=6000179;//user.Main:179
      Tonyu.globals.$p=new Tonyu.classes.user.Player({x: 50,y: 150,p: Tonyu.globals.$pat_player,fillStyle: "#a00"});
      //$LASTPOS=6000237;//user.Main:237
      Tonyu.globals.$pzScreen=new Tonyu.classes.user.PzScreen({x: Tonyu.globals.$screenWidth/2,y: Tonyu.globals.$screenHeight-32*(Tonyu.globals.$r/2),width: Tonyu.globals.$c*32,height: 32*Tonyu.globals.$r});
      //$LASTPOS=6000333;//user.Main:333
      //$LASTPOS=6000338;//user.Main:338
      _this.i=Tonyu.globals.$r-1;for (; _this.i>=0 ; _this.i--) {
        Tonyu.checkLoop();
        {
          //$LASTPOS=6000361;//user.Main:361
          //$LASTPOS=6000366;//user.Main:366
          _this.j=0;for (; _this.j<Tonyu.globals.$c ; _this.j++) {
            Tonyu.checkLoop();
            {
              //$LASTPOS=6000390;//user.Main:390
              Tonyu.globals.$pzScreen.genDBall(_this.j,_this.i-Tonyu.globals.$r,Tonyu.globals.$pat_iroball+_this.rnd(25));
            }
          }
        }
      }
      //$LASTPOS=6000456;//user.Main:456
      while (true) {
        Tonyu.checkLoop();
        //$LASTPOS=6000505;//user.Main:505
        if (_this.chain) {
          //$LASTPOS=6000526;//user.Main:526
          if (_this.chain.isDead()) {
            //$LASTPOS=6000546;//user.Main:546
            _this.chain=null;
          }
          
        } else {
          //$LASTPOS=6000569;//user.Main:569
          if (Tonyu.globals.$touches[0].touched==1) {
            //$LASTPOS=6000607;//user.Main:607
            _this.g = Tonyu.globals.$pzScreen.grid(Tonyu.globals.$touches[0]);
            
            //$LASTPOS=6000650;//user.Main:650
            _this.b = Tonyu.globals.$pzScreen.getSBall(_this.g.gx,_this.g.gy);
            
            //$LASTPOS=6000695;//user.Main:695
            if (_this.b) {
              //$LASTPOS=6000716;//user.Main:716
              _this.chain=new Tonyu.classes.user.Chain({gx: _this.g.gx,gy: _this.g.gy,layer: Tonyu.globals.$pzScreen.ballLayer});
              
            }
            
          }
        }
        //$LASTPOS=6001108;//user.Main:1108
        _this.update();
        
      }
    },
    fiber$main :function _trc_Main_f_main(_thread) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      
      
      //$LASTPOS=6000017;//user.Main:17
      Tonyu.globals.$r=5;
      //$LASTPOS=6000022;//user.Main:22
      Tonyu.globals.$c=6;
      //$LASTPOS=6000028;//user.Main:28
      Tonyu.globals.$Screen.setBGColor("black");
      //$LASTPOS=6000057;//user.Main:57
      Tonyu.globals.$Screen.resize(Tonyu.globals.$c*32,Tonyu.globals.$r*64);
      //$LASTPOS=6000086;//user.Main:86
      _this.m=new Tonyu.classes.user.MakePat;
      
      _thread.enter(function _trc_Main_ent_main(_thread) {
        if (_thread.lastEx) __pc=_thread.catchPC;
        for(var __cnt=100 ; __cnt--;) {
          switch (__pc) {
          case 0:
            //$LASTPOS=6000101;//user.Main:101
            _this.fiber$waitEvent(_thread, _this.m, "die");
            __pc=1;return;
          case 1:
            
            //$LASTPOS=6000121;//user.Main:121
            Tonyu.globals.$e=new Tonyu.classes.user.Enemy({x: 100,y: 100,p: Tonyu.globals.$pat_enemy1,fillStyle: "#ff0"});
            //$LASTPOS=6000179;//user.Main:179
            Tonyu.globals.$p=new Tonyu.classes.user.Player({x: 50,y: 150,p: Tonyu.globals.$pat_player,fillStyle: "#a00"});
            //$LASTPOS=6000237;//user.Main:237
            Tonyu.globals.$pzScreen=new Tonyu.classes.user.PzScreen({x: Tonyu.globals.$screenWidth/2,y: Tonyu.globals.$screenHeight-32*(Tonyu.globals.$r/2),width: Tonyu.globals.$c*32,height: 32*Tonyu.globals.$r});
            //$LASTPOS=6000333;//user.Main:333
            //$LASTPOS=6000338;//user.Main:338
            _this.i=Tonyu.globals.$r-1;for (; _this.i>=0 ; _this.i--) {
              Tonyu.checkLoop();
              {
                //$LASTPOS=6000361;//user.Main:361
                //$LASTPOS=6000366;//user.Main:366
                _this.j=0;for (; _this.j<Tonyu.globals.$c ; _this.j++) {
                  Tonyu.checkLoop();
                  {
                    //$LASTPOS=6000390;//user.Main:390
                    Tonyu.globals.$pzScreen.genDBall(_this.j,_this.i-Tonyu.globals.$r,Tonyu.globals.$pat_iroball+_this.rnd(25));
                  }
                }
              }
            }
            //$LASTPOS=6000456;//user.Main:456
          case 2:
            //$LASTPOS=6000505;//user.Main:505
            if (_this.chain) {
              //$LASTPOS=6000526;//user.Main:526
              if (_this.chain.isDead()) {
                //$LASTPOS=6000546;//user.Main:546
                _this.chain=null;
              }
              
            } else {
              //$LASTPOS=6000569;//user.Main:569
              if (Tonyu.globals.$touches[0].touched==1) {
                //$LASTPOS=6000607;//user.Main:607
                _this.g = Tonyu.globals.$pzScreen.grid(Tonyu.globals.$touches[0]);
                
                //$LASTPOS=6000650;//user.Main:650
                _this.b = Tonyu.globals.$pzScreen.getSBall(_this.g.gx,_this.g.gy);
                
                //$LASTPOS=6000695;//user.Main:695
                if (_this.b) {
                  //$LASTPOS=6000716;//user.Main:716
                  _this.chain=new Tonyu.classes.user.Chain({gx: _this.g.gx,gy: _this.g.gy,layer: Tonyu.globals.$pzScreen.ballLayer});
                  
                }
                
              }
            }
            //$LASTPOS=6001108;//user.Main:1108
            _this.fiber$update(_thread);
            __pc=3;return;
          case 3:
            
            __pc=2;break;
          case 4     :
            
            _thread.exit(_this);return;
          }
        }
      });
    },
    __dummy: false
  },
  decls: {"methods":{"main":{"nowait":false}},"fields":{"m":{},"i":{},"j":{},"chain":{},"g":{},"b":{}}}
});
Tonyu.klass.define({
  fullName: 'user.MakePat',
  shortName: 'MakePat',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: {
    main :function _trc_MakePat_main() {
      "use strict";
      var _this=this;
      
      //$LASTPOS=7000000;//user.MakePat:0
      _this.x=_this.y=0;
      //$LASTPOS=7000006;//user.MakePat:6
      _this.p=- 1;
      //$LASTPOS=7000059;//user.MakePat:59
      _this.drawLight(_this.x,_this.y);
      //$LASTPOS=7000075;//user.MakePat:75
      Tonyu.globals.$pshade=Tonyu.globals.$panel.addPattern(0,0,32,32);
      //$LASTPOS=7000113;//user.MakePat:113
      _this.update();
      //$LASTPOS=7000123;//user.MakePat:123
      _this.die();
    },
    fiber$main :function _trc_MakePat_f_main(_thread) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      
      //$LASTPOS=7000000;//user.MakePat:0
      _this.x=_this.y=0;
      //$LASTPOS=7000006;//user.MakePat:6
      _this.p=- 1;
      
      _thread.enter(function _trc_MakePat_ent_main(_thread) {
        if (_thread.lastEx) __pc=_thread.catchPC;
        for(var __cnt=100 ; __cnt--;) {
          switch (__pc) {
          case 0:
            //$LASTPOS=7000059;//user.MakePat:59
            _this.fiber$drawLight(_thread, _this.x, _this.y);
            __pc=1;return;
          case 1:
            
            //$LASTPOS=7000075;//user.MakePat:75
            Tonyu.globals.$pshade=Tonyu.globals.$panel.addPattern(0,0,32,32);
            //$LASTPOS=7000113;//user.MakePat:113
            _this.fiber$update(_thread);
            __pc=2;return;
          case 2:
            
            //$LASTPOS=7000123;//user.MakePat:123
            _this.die();
            _thread.exit(_this);return;
          }
        }
      });
    },
    drawLight :function _trc_MakePat_drawLight(bx,by) {
      "use strict";
      var _this=this;
      var li;
      var ce;
      
      //$LASTPOS=7000256;//user.MakePat:256
      li = new Tonyu.classes.kernel.Vec3(8,8);
      ce = new Tonyu.classes.kernel.Vec3(16,16);
      
      //$LASTPOS=7000302;//user.MakePat:302
      Tonyu.globals.$panel.replaceColor(bx,by,32,32,(function anonymous_336(c,x,y) {
        var p;
        var d;
        var cd;
        
        //$LASTPOS=7000355;//user.MakePat:355
        x-=bx;
        //$LASTPOS=7000361;//user.MakePat:361
        y-=by;
        //$LASTPOS=7000376;//user.MakePat:376
        p = new Tonyu.classes.kernel.Vec3(x,y);
        
        //$LASTPOS=7000405;//user.MakePat:405
        d = p.sub(li).length;
        
        //$LASTPOS=7000437;//user.MakePat:437
        if (d<5) {
          //$LASTPOS=7000446;//user.MakePat:446
          c.setHSLA(0,0,1,255-d*30);
        }
        //$LASTPOS=7000510;//user.MakePat:510
        cd = p.sub(ce).length;
        
        //$LASTPOS=7000543;//user.MakePat:543
        if (d>15&&cd<16) {
          //$LASTPOS=7000576;//user.MakePat:576
          c.setHSLA(0,0,0,(d-15)*20);
          
        }
      }));
    },
    fiber$drawLight :function _trc_MakePat_f_drawLight(_thread,bx,by) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      var li;
      var ce;
      
      //$LASTPOS=7000256;//user.MakePat:256
      li = new Tonyu.classes.kernel.Vec3(8,8);
      ce = new Tonyu.classes.kernel.Vec3(16,16);
      
      //$LASTPOS=7000302;//user.MakePat:302
      Tonyu.globals.$panel.replaceColor(bx,by,32,32,(function anonymous_336(c,x,y) {
        var p;
        var d;
        var cd;
        
        //$LASTPOS=7000355;//user.MakePat:355
        x-=bx;
        //$LASTPOS=7000361;//user.MakePat:361
        y-=by;
        //$LASTPOS=7000376;//user.MakePat:376
        p = new Tonyu.classes.kernel.Vec3(x,y);
        
        //$LASTPOS=7000405;//user.MakePat:405
        d = p.sub(li).length;
        
        //$LASTPOS=7000437;//user.MakePat:437
        if (d<5) {
          //$LASTPOS=7000446;//user.MakePat:446
          c.setHSLA(0,0,1,255-d*30);
        }
        //$LASTPOS=7000510;//user.MakePat:510
        cd = p.sub(ce).length;
        
        //$LASTPOS=7000543;//user.MakePat:543
        if (d>15&&cd<16) {
          //$LASTPOS=7000576;//user.MakePat:576
          c.setHSLA(0,0,0,(d-15)*20);
          
        }
      }));
      
      _thread.retVal=_this;return;
    },
    __dummy: false
  },
  decls: {"methods":{"main":{"nowait":false},"drawLight":{"nowait":false}},"fields":{}}
});
Tonyu.klass.define({
  fullName: 'user.MkPlPat',
  shortName: 'MkPlPat',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: {
    main :function _trc_MkPlPat_main() {
      "use strict";
      var _this=this;
      
      //$LASTPOS=10000000;//user.MkPlPat:0
      Tonyu.globals.$Screen.setBGColor("#aaa");
      //$LASTPOS=10000028;//user.MkPlPat:28
      _this.panel = new Tonyu.classes.kernel.Panel({x: 100,y: 100,width: 16*9,height: 16});
      
      //$LASTPOS=10000084;//user.MkPlPat:84
      _this.p=Tonyu.globals.$pat_mgoku+5;
      //$LASTPOS=10000100;//user.MkPlPat:100
      //$LASTPOS=10000105;//user.MkPlPat:105
      _this.i = 0;
      for (; _this.i<9 ; _this.i++) {
        Tonyu.checkLoop();
        {
          //$LASTPOS=10000128;//user.MkPlPat:128
          _this.panel.drawSprite(16*_this.i+8,8,_this.p);
          //$LASTPOS=10000162;//user.MkPlPat:162
          _this.p++;
        }
      }
      //$LASTPOS=10000169;//user.MkPlPat:169
      _this.panel.replaceColor(0,0,9*16,16,(function anonymous_201(c) {
        
        //$LASTPOS=10000212;//user.MkPlPat:212
        if (c.distRGBA(new Tonyu.classes.kernel.Color(0,0,0))<0.1) {
          //$LASTPOS=10000260;//user.MkPlPat:260
          c.setRGBA(0,0,0,0);
          
        }
      }));
      //$LASTPOS=10000289;//user.MkPlPat:289
      _this.panel.save("player.png");
    },
    fiber$main :function _trc_MkPlPat_f_main(_thread) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      
      //$LASTPOS=10000000;//user.MkPlPat:0
      Tonyu.globals.$Screen.setBGColor("#aaa");
      //$LASTPOS=10000028;//user.MkPlPat:28
      _this.panel = new Tonyu.classes.kernel.Panel({x: 100,y: 100,width: 16*9,height: 16});
      
      //$LASTPOS=10000084;//user.MkPlPat:84
      _this.p=Tonyu.globals.$pat_mgoku+5;
      //$LASTPOS=10000100;//user.MkPlPat:100
      //$LASTPOS=10000105;//user.MkPlPat:105
      _this.i = 0;
      for (; _this.i<9 ; _this.i++) {
        Tonyu.checkLoop();
        {
          //$LASTPOS=10000128;//user.MkPlPat:128
          _this.panel.drawSprite(16*_this.i+8,8,_this.p);
          //$LASTPOS=10000162;//user.MkPlPat:162
          _this.p++;
        }
      }
      //$LASTPOS=10000169;//user.MkPlPat:169
      _this.panel.replaceColor(0,0,9*16,16,(function anonymous_201(c) {
        
        //$LASTPOS=10000212;//user.MkPlPat:212
        if (c.distRGBA(new Tonyu.classes.kernel.Color(0,0,0))<0.1) {
          //$LASTPOS=10000260;//user.MkPlPat:260
          c.setRGBA(0,0,0,0);
          
        }
      }));
      //$LASTPOS=10000289;//user.MkPlPat:289
      _this.panel.save("player.png");
      
      _thread.retVal=_this;return;
    },
    __dummy: false
  },
  decls: {"methods":{"main":{"nowait":false}},"fields":{"panel":{},"i":{}}}
});
Tonyu.klass.define({
  fullName: 'user.Player',
  shortName: 'Player',
  namespace: 'user',
  superclass: Tonyu.classes.user.ColorSprite,
  includes: [],
  methods: {
    main :function _trc_Player_main() {
      "use strict";
      var _this=this;
      
      //$LASTPOS=11000022;//user.Player:22
      _this.scaleX=2;
    },
    fiber$main :function _trc_Player_f_main(_thread) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      
      //$LASTPOS=11000022;//user.Player:22
      _this.scaleX=2;
      
      _thread.retVal=_this;return;
    },
    __dummy: false
  },
  decls: {"methods":{"main":{"nowait":false}},"fields":{}}
});
Tonyu.klass.define({
  fullName: 'user.PzScreen',
  shortName: 'PzScreen',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Screen,
  includes: [],
  methods: {
    main :function _trc_PzScreen_main() {
      "use strict";
      var _this=this;
      
      
    },
    fiber$main :function _trc_PzScreen_f_main(_thread) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      
      
      
      _thread.retVal=_this;return;
    },
    onAppear :function _trc_PzScreen_onAppear() {
      "use strict";
      var _this=this;
      var c;
      
      //$LASTPOS=8000053;//user.PzScreen:53
      _this.ballLayer=_this.addLayer();
      //$LASTPOS=8000079;//user.PzScreen:79
      _this.mat=new Tonyu.classes.kernel.Matrix;
      //$LASTPOS=8000099;//user.PzScreen:99
      Tonyu.globals.$zoomScreen=new Tonyu.classes.kernel.Screen({x: Tonyu.globals.$screenWidth/2,y: 100,width: 96,height: 96});
      //$LASTPOS=8000184;//user.PzScreen:184
      Tonyu.globals.$zoomScreen.addLayer(_this.ballLayer.group);
      //$LASTPOS=8000227;//user.PzScreen:227
      Tonyu.globals.$zoomScreen.selectLayer(_this.ballLayer.group);
      //$LASTPOS=8000273;//user.PzScreen:273
      Tonyu.globals.$zoomScreen.setPivot(48,48);
      //$LASTPOS=8000306;//user.PzScreen:306
      Tonyu.globals.$zoomScreen.alpha=0;
      //$LASTPOS=8000331;//user.PzScreen:331
      c = Tonyu.globals.$zoomScreen.context;
      
      //$LASTPOS=8000362;//user.PzScreen:362
      c.arc(48,48,48,0,Tonyu.globals.$Math.PI*2);
      //$LASTPOS=8000396;//user.PzScreen:396
      c.clip();
    },
    fiber$onAppear :function _trc_PzScreen_f_onAppear(_thread) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      var c;
      
      
      _thread.enter(function _trc_PzScreen_ent_onAppear(_thread) {
        if (_thread.lastEx) __pc=_thread.catchPC;
        for(var __cnt=100 ; __cnt--;) {
          switch (__pc) {
          case 0:
            //$LASTPOS=8000053;//user.PzScreen:53
            _this.fiber$addLayer(_thread);
            __pc=1;return;
          case 1:
            _this.ballLayer=_thread.retVal;
            
            //$LASTPOS=8000079;//user.PzScreen:79
            _this.mat=new Tonyu.classes.kernel.Matrix;
            //$LASTPOS=8000099;//user.PzScreen:99
            Tonyu.globals.$zoomScreen=new Tonyu.classes.kernel.Screen({x: Tonyu.globals.$screenWidth/2,y: 100,width: 96,height: 96});
            //$LASTPOS=8000184;//user.PzScreen:184
            Tonyu.globals.$zoomScreen.addLayer(_this.ballLayer.group);
            //$LASTPOS=8000227;//user.PzScreen:227
            Tonyu.globals.$zoomScreen.selectLayer(_this.ballLayer.group);
            //$LASTPOS=8000273;//user.PzScreen:273
            Tonyu.globals.$zoomScreen.setPivot(48,48);
            //$LASTPOS=8000306;//user.PzScreen:306
            Tonyu.globals.$zoomScreen.alpha=0;
            //$LASTPOS=8000331;//user.PzScreen:331
            c = Tonyu.globals.$zoomScreen.context;
            
            //$LASTPOS=8000362;//user.PzScreen:362
            c.arc(48,48,48,0,Tonyu.globals.$Math.PI*2);
            //$LASTPOS=8000396;//user.PzScreen:396
            c.clip();
            _thread.exit(_this);return;
          }
        }
      });
    },
    zoom :function _trc_PzScreen_zoom(p) {
      "use strict";
      var _this=this;
      
      //$LASTPOS=8000423;//user.PzScreen:423
      if (p) {
        //$LASTPOS=8000440;//user.PzScreen:440
        Tonyu.globals.$zoomScreen.alpha=255;
        //$LASTPOS=8000471;//user.PzScreen:471
        Tonyu.globals.$zoomScreen.scrollTo(p.x,p.y);
        
      } else {
        //$LASTPOS=8000523;//user.PzScreen:523
        Tonyu.globals.$zoomScreen.alpha=0;
        
      }
    },
    fiber$zoom :function _trc_PzScreen_f_zoom(_thread,p) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      
      //$LASTPOS=8000423;//user.PzScreen:423
      if (p) {
        //$LASTPOS=8000440;//user.PzScreen:440
        Tonyu.globals.$zoomScreen.alpha=255;
        //$LASTPOS=8000471;//user.PzScreen:471
        Tonyu.globals.$zoomScreen.scrollTo(p.x,p.y);
        
      } else {
        //$LASTPOS=8000523;//user.PzScreen:523
        Tonyu.globals.$zoomScreen.alpha=0;
        
      }
      
      _thread.retVal=_this;return;
    },
    toLocal :function _trc_PzScreen_toLocal(touch) {
      "use strict";
      var _this=this;
      var pt;
      
      //$LASTPOS=8000574;//user.PzScreen:574
      touch.layer=_this.layer;
      //$LASTPOS=8000597;//user.PzScreen:597
      pt = _this.convert(touch);
      
      return pt;
    },
    fiber$toLocal :function _trc_PzScreen_f_toLocal(_thread,touch) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      var pt;
      
      //$LASTPOS=8000574;//user.PzScreen:574
      touch.layer=_this.layer;
      
      _thread.enter(function _trc_PzScreen_ent_toLocal(_thread) {
        if (_thread.lastEx) __pc=_thread.catchPC;
        for(var __cnt=100 ; __cnt--;) {
          switch (__pc) {
          case 0:
            //$LASTPOS=8000597;//user.PzScreen:597
            _this.fiber$convert(_thread, touch);
            __pc=1;return;
          case 1:
            pt=_thread.retVal;
            
            _thread.exit(pt);return;
            _thread.exit(_this);return;
          }
        }
      });
    },
    grid :function _trc_PzScreen_grid(touch) {
      "use strict";
      var _this=this;
      var pt;
      var gx;
      var gy;
      
      //$LASTPOS=8000660;//user.PzScreen:660
      pt = _this.toLocal(touch);
      
      //$LASTPOS=8000687;//user.PzScreen:687
      gx = _this.floor(pt.x/32);
      gy = _this.floor(pt.y/32);
      
      return {gx: gx,gy: gy};
    },
    fiber$grid :function _trc_PzScreen_f_grid(_thread,touch) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      var pt;
      var gx;
      var gy;
      
      
      _thread.enter(function _trc_PzScreen_ent_grid(_thread) {
        if (_thread.lastEx) __pc=_thread.catchPC;
        for(var __cnt=100 ; __cnt--;) {
          switch (__pc) {
          case 0:
            //$LASTPOS=8000660;//user.PzScreen:660
            _this.fiber$toLocal(_thread, touch);
            __pc=1;return;
          case 1:
            pt=_thread.retVal;
            
            //$LASTPOS=8000687;//user.PzScreen:687
            gx = _this.floor(pt.x/32);
            gy = _this.floor(pt.y/32);
            
            _thread.exit({gx: gx,gy: gy});return;
            _thread.exit(_this);return;
          }
        }
      });
    },
    ballOnTouch :function _trc_PzScreen_ballOnTouch(touch) {
      "use strict";
      var _this=this;
      var g;
      
      //$LASTPOS=8000776;//user.PzScreen:776
      g = _this.grid(touch);
      
      return _this.mat.get(g.gx,g.gy);
    },
    fiber$ballOnTouch :function _trc_PzScreen_f_ballOnTouch(_thread,touch) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      var g;
      
      
      _thread.enter(function _trc_PzScreen_ent_ballOnTouch(_thread) {
        if (_thread.lastEx) __pc=_thread.catchPC;
        for(var __cnt=100 ; __cnt--;) {
          switch (__pc) {
          case 0:
            //$LASTPOS=8000776;//user.PzScreen:776
            _this.fiber$grid(_thread, touch);
            __pc=1;return;
          case 1:
            g=_thread.retVal;
            
            _thread.exit(_this.mat.get(g.gx,g.gy));return;
            _thread.exit(_this);return;
          }
        }
      });
    },
    getSBall :function _trc_PzScreen_getSBall(gx,gy) {
      "use strict";
      var _this=this;
      
      return _this.mat.get(gx,gy);
    },
    fiber$getSBall :function _trc_PzScreen_f_getSBall(_thread,gx,gy) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      
      _thread.retVal=_this.mat.get(gx,gy);return;
      
      
      _thread.retVal=_this;return;
    },
    rm :function _trc_PzScreen_rm(gx,gy) {
      "use strict";
      var _this=this;
      var b;
      
      //$LASTPOS=8000950;//user.PzScreen:950
      b = _this.mat.get(gx,gy);
      
      //$LASTPOS=8000976;//user.PzScreen:976
      if (b) {
        //$LASTPOS=8000993;//user.PzScreen:993
        b.die();
        //$LASTPOS=8001010;//user.PzScreen:1010
        _this.mat.set(gx,gy);
        return b;
        
      }
    },
    fiber$rm :function _trc_PzScreen_f_rm(_thread,gx,gy) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      var b;
      
      //$LASTPOS=8000950;//user.PzScreen:950
      b = _this.mat.get(gx,gy);
      
      //$LASTPOS=8000976;//user.PzScreen:976
      if (b) {
        //$LASTPOS=8000993;//user.PzScreen:993
        b.die();
        //$LASTPOS=8001010;//user.PzScreen:1010
        _this.mat.set(gx,gy);
        _thread.retVal=b;return;
        
        
      }
      
      _thread.retVal=_this;return;
    },
    fill :function _trc_PzScreen_fill() {
      "use strict";
      var _this=this;
      var j;
      var i;
      var n;
      var b;
      
      
      //$LASTPOS=8001079;//user.PzScreen:1079
      //$LASTPOS=8001084;//user.PzScreen:1084
      j=0;for (; j<Tonyu.globals.$c ; j++) {
        Tonyu.checkLoop();
        {
          //$LASTPOS=8001108;//user.PzScreen:1108
          n = 0;
          
          //$LASTPOS=8001125;//user.PzScreen:1125
          //$LASTPOS=8001130;//user.PzScreen:1130
          i=Tonyu.globals.$r-1;for (; i>=0 ; i--) {
            Tonyu.checkLoop();
            {
              //$LASTPOS=8001162;//user.PzScreen:1162
              b = _this.getSBall(j,i);
              
              //$LASTPOS=8001195;//user.PzScreen:1195
              if (! b) {
                //$LASTPOS=8001221;//user.PzScreen:1221
                n++;
                
              } else {
                //$LASTPOS=8001263;//user.PzScreen:1263
                if (n) {
                  //$LASTPOS=8001292;//user.PzScreen:1292
                  _this.rm(j,i);
                  //$LASTPOS=8001321;//user.PzScreen:1321
                  _this.genDBall(j,i,b.p);
                  
                }
                
              }
            }
          }
          //$LASTPOS=8001390;//user.PzScreen:1390
          //$LASTPOS=8001395;//user.PzScreen:1395
          i=- 1;for (; i>=- n ; i--) {
            Tonyu.checkLoop();
            {
              //$LASTPOS=8001425;//user.PzScreen:1425
              _this.genDBall(j,i,Tonyu.globals.$pat_iroball+_this.rnd(25));
            }
          }
        }
      }
    },
    fiber$fill :function _trc_PzScreen_f_fill(_thread) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      var j;
      var i;
      var n;
      var b;
      
      
      
      _thread.enter(function _trc_PzScreen_ent_fill(_thread) {
        if (_thread.lastEx) __pc=_thread.catchPC;
        for(var __cnt=100 ; __cnt--;) {
          switch (__pc) {
          case 0:
            //$LASTPOS=8001079;//user.PzScreen:1079
            //$LASTPOS=8001084;//user.PzScreen:1084
            j=0;
          case 1:
            if (!(j<Tonyu.globals.$c)) { __pc=16    ; break; }
            //$LASTPOS=8001108;//user.PzScreen:1108
            n = 0;
            
            //$LASTPOS=8001125;//user.PzScreen:1125
            //$LASTPOS=8001130;//user.PzScreen:1130
            i=Tonyu.globals.$r-1;
          case 2:
            if (!(i>=0)) { __pc=10    ; break; }
            //$LASTPOS=8001162;//user.PzScreen:1162
            _this.fiber$getSBall(_thread, j, i);
            __pc=3;return;
          case 3:
            b=_thread.retVal;
            
            //$LASTPOS=8001195;//user.PzScreen:1195
            if (!(! b)) { __pc=4     ; break; }
            {
              //$LASTPOS=8001221;//user.PzScreen:1221
              n++;
            }
            __pc=8     ;break;
          case 4     :
            //$LASTPOS=8001263;//user.PzScreen:1263
            if (!(n)) { __pc=7     ; break; }
            //$LASTPOS=8001292;//user.PzScreen:1292
            _this.fiber$rm(_thread, j, i);
            __pc=5;return;
          case 5:
            
            //$LASTPOS=8001321;//user.PzScreen:1321
            _this.fiber$genDBall(_thread, j, i, b.p);
            __pc=6;return;
          case 6:
            
          case 7     :
            
          case 8     :
            
          case 9     :
            i--;
            __pc=2;break;
          case 10    :
            
            //$LASTPOS=8001390;//user.PzScreen:1390
            //$LASTPOS=8001395;//user.PzScreen:1395
            i=- 1;
          case 11:
            if (!(i>=- n)) { __pc=14    ; break; }
            //$LASTPOS=8001425;//user.PzScreen:1425
            _this.fiber$genDBall(_thread, j, i, Tonyu.globals.$pat_iroball+_this.rnd(25));
            __pc=12;return;
          case 12:
            
          case 13    :
            i--;
            __pc=11;break;
          case 14    :
            
          case 15    :
            j++;
            __pc=1;break;
          case 16    :
            
            _thread.exit(_this);return;
          }
        }
      });
    },
    genSBall :function _trc_PzScreen_genSBall(gx,gy,p) {
      "use strict";
      var _this=this;
      var sb;
      
      //$LASTPOS=8001505;//user.PzScreen:1505
      sb = new Tonyu.classes.user.Ball({x: gx*32+16,y: gy*32+16,p: p,layer: _this.ballLayer,scr: _this});
      
      //$LASTPOS=8001628;//user.PzScreen:1628
      _this.mat.set(gx,gy,sb);
      return sb;
    },
    fiber$genSBall :function _trc_PzScreen_f_genSBall(_thread,gx,gy,p) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      var sb;
      
      //$LASTPOS=8001505;//user.PzScreen:1505
      sb = new Tonyu.classes.user.Ball({x: gx*32+16,y: gy*32+16,p: p,layer: _this.ballLayer,scr: _this});
      
      //$LASTPOS=8001628;//user.PzScreen:1628
      _this.mat.set(gx,gy,sb);
      _thread.retVal=sb;return;
      
      
      _thread.retVal=_this;return;
    },
    genDBall :function _trc_PzScreen_genDBall(gx,gy,p) {
      "use strict";
      var _this=this;
      
      return new Tonyu.classes.user.DBall({x: gx*32+16,y: gy*32+16,p: p,layer: _this.ballLayer,scr: _this});
    },
    fiber$genDBall :function _trc_PzScreen_f_genDBall(_thread,gx,gy,p) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      
      _thread.retVal=new Tonyu.classes.user.DBall({x: gx*32+16,y: gy*32+16,p: p,layer: _this.ballLayer,scr: _this});return;
      
      
      _thread.retVal=_this;return;
    },
    __dummy: false
  },
  decls: {"methods":{"main":{"nowait":false},"onAppear":{"nowait":false},"zoom":{"nowait":false},"toLocal":{"nowait":false},"grid":{"nowait":false},"ballOnTouch":{"nowait":false},"getSBall":{"nowait":false},"rm":{"nowait":false},"fill":{"nowait":false},"genSBall":{"nowait":false},"genDBall":{"nowait":false}},"fields":{"ballLayer":{},"mat":{}}}
});
Tonyu.klass.define({
  fullName: 'user.Turtle',
  shortName: 'Turtle',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: {
    main :function _trc_Turtle_main() {
      "use strict";
      var _this=this;
      
      
    },
    fiber$main :function _trc_Turtle_f_main(_thread) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      
      
      
      _thread.retVal=_this;return;
    },
    initialize :function _trc_Turtle_initialize(context,x,y) {
      "use strict";
      var _this=this;
      
      //$LASTPOS=9000073;//user.Turtle:73
      _this.context=context;
      //$LASTPOS=9000099;//user.Turtle:99
      _this.x=x||0;
      //$LASTPOS=9000116;//user.Turtle:116
      _this.y=y||0;
      //$LASTPOS=9000133;//user.Turtle:133
      _this.dir=0;
      //$LASTPOS=9000144;//user.Turtle:144
      _this.autoDraw=true;
      //$LASTPOS=9000163;//user.Turtle:163
      _this.doFill=true;
    },
    __setter__lineWidth :function _trc_Turtle___setter__lineWidth(x) {
      "use strict";
      var _this=this;
      
      //$LASTPOS=9000197;//user.Turtle:197
      _this.context.lineWidth=x;
    },
    __setter__fillStyle :function _trc_Turtle___setter__fillStyle(f) {
      "use strict";
      var _this=this;
      
      //$LASTPOS=9000239;//user.Turtle:239
      _this.context.fillStyle=f;
      //$LASTPOS=9000264;//user.Turtle:264
      _this.doFill=! ! f;
    },
    __setter__strokeStyle :function _trc_Turtle___setter__strokeStyle(f) {
      "use strict";
      var _this=this;
      
      //$LASTPOS=9000299;//user.Turtle:299
      _this.doStroke=! ! f;
      //$LASTPOS=9000317;//user.Turtle:317
      _this.context.strokeStyle=f;
    },
    beginPath :function _trc_Turtle_beginPath() {
      "use strict";
      var _this=this;
      
      //$LASTPOS=9000361;//user.Turtle:361
      _this.context.beginPath();
      //$LASTPOS=9000386;//user.Turtle:386
      _this.autoDraw=false;
      //$LASTPOS=9000406;//user.Turtle:406
      _this.px=null;
    },
    fiber$beginPath :function _trc_Turtle_f_beginPath(_thread) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      
      //$LASTPOS=9000361;//user.Turtle:361
      _this.context.beginPath();
      //$LASTPOS=9000386;//user.Turtle:386
      _this.autoDraw=false;
      //$LASTPOS=9000406;//user.Turtle:406
      _this.px=null;
      
      _thread.retVal=_this;return;
    },
    closePath :function _trc_Turtle_closePath() {
      "use strict";
      var _this=this;
      
      //$LASTPOS=9000436;//user.Turtle:436
      _this.context.closePath();
      //$LASTPOS=9000461;//user.Turtle:461
      _this.autoDraw=true;
    },
    fiber$closePath :function _trc_Turtle_f_closePath(_thread) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      
      //$LASTPOS=9000436;//user.Turtle:436
      _this.context.closePath();
      //$LASTPOS=9000461;//user.Turtle:461
      _this.autoDraw=true;
      
      _thread.retVal=_this;return;
    },
    rotate :function _trc_Turtle_rotate(r) {
      "use strict";
      var _this=this;
      
      //$LASTPOS=9000495;//user.Turtle:495
      _this.dir+=r;
    },
    fiber$rotate :function _trc_Turtle_f_rotate(_thread,r) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      
      //$LASTPOS=9000495;//user.Turtle:495
      _this.dir+=r;
      
      _thread.retVal=_this;return;
    },
    forward :function _trc_Turtle_forward(s) {
      "use strict";
      var _this=this;
      
      //$LASTPOS=9000523;//user.Turtle:523
      _this.x+=_this.cos(_this.dir)*s;
      //$LASTPOS=9000542;//user.Turtle:542
      _this.y+=_this.sin(_this.dir)*s;
      //$LASTPOS=9000561;//user.Turtle:561
      _this.lineTo(_this.x,_this.y);
    },
    fiber$forward :function _trc_Turtle_f_forward(_thread,s) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      
      //$LASTPOS=9000523;//user.Turtle:523
      _this.x+=_this.cos(_this.dir)*s;
      //$LASTPOS=9000542;//user.Turtle:542
      _this.y+=_this.sin(_this.dir)*s;
      
      _thread.enter(function _trc_Turtle_ent_forward(_thread) {
        if (_thread.lastEx) __pc=_thread.catchPC;
        for(var __cnt=100 ; __cnt--;) {
          switch (__pc) {
          case 0:
            //$LASTPOS=9000561;//user.Turtle:561
            _this.fiber$lineTo(_thread, _this.x, _this.y);
            __pc=1;return;
          case 1:
            
            _thread.exit(_this);return;
          }
        }
      });
    },
    moveTo :function _trc_Turtle_moveTo(x,y) {
      "use strict";
      var _this=this;
      
      //$LASTPOS=9000595;//user.Turtle:595
      _this.x=x;
      //$LASTPOS=9000609;//user.Turtle:609
      _this.y=y;
      //$LASTPOS=9000623;//user.Turtle:623
      _this.px=x;
      //$LASTPOS=9000633;//user.Turtle:633
      _this.py=y;
      //$LASTPOS=9000643;//user.Turtle:643
      _this.context.moveTo(x,y);
    },
    fiber$moveTo :function _trc_Turtle_f_moveTo(_thread,x,y) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      
      //$LASTPOS=9000595;//user.Turtle:595
      _this.x=x;
      //$LASTPOS=9000609;//user.Turtle:609
      _this.y=y;
      //$LASTPOS=9000623;//user.Turtle:623
      _this.px=x;
      //$LASTPOS=9000633;//user.Turtle:633
      _this.py=y;
      //$LASTPOS=9000643;//user.Turtle:643
      _this.context.moveTo(x,y);
      
      _thread.retVal=_this;return;
    },
    lineTo :function _trc_Turtle_lineTo(x,y) {
      "use strict";
      var _this=this;
      
      //$LASTPOS=9000685;//user.Turtle:685
      _this.x=x;
      //$LASTPOS=9000699;//user.Turtle:699
      _this.y=y;
      //$LASTPOS=9000713;//user.Turtle:713
      if (_this.px==null) {
        //$LASTPOS=9000737;//user.Turtle:737
        _this.px=x;
        //$LASTPOS=9000742;//user.Turtle:742
        _this.py=y;
        return _this;
        
      }
      //$LASTPOS=9000765;//user.Turtle:765
      if (_this.autoDraw) {
        //$LASTPOS=9000789;//user.Turtle:789
        _this.enter((function anonymous_794() {
          
          //$LASTPOS=9000809;//user.Turtle:809
          _this.context.beginPath();
          //$LASTPOS=9000842;//user.Turtle:842
          _this.context.moveTo(_this.px,_this.py);
          //$LASTPOS=9000877;//user.Turtle:877
          _this.context.lineTo(x,y);
          //$LASTPOS=9000910;//user.Turtle:910
          _this.context.closePath();
          //$LASTPOS=9000943;//user.Turtle:943
          _this.fillAndStroke();
        }));
        
      } else {
        //$LASTPOS=9000992;//user.Turtle:992
        _this.context.lineTo(x,y);
        
      }
      //$LASTPOS=9001023;//user.Turtle:1023
      _this.px=x;
      //$LASTPOS=9001028;//user.Turtle:1028
      _this.py=y;
    },
    fiber$lineTo :function _trc_Turtle_f_lineTo(_thread,x,y) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      
      //$LASTPOS=9000685;//user.Turtle:685
      _this.x=x;
      //$LASTPOS=9000699;//user.Turtle:699
      _this.y=y;
      //$LASTPOS=9000713;//user.Turtle:713
      if (_this.px==null) {
        //$LASTPOS=9000737;//user.Turtle:737
        _this.px=x;
        //$LASTPOS=9000742;//user.Turtle:742
        _this.py=y;
        _thread.retVal=_this;return;
        
        
      }
      
      _thread.enter(function _trc_Turtle_ent_lineTo(_thread) {
        if (_thread.lastEx) __pc=_thread.catchPC;
        for(var __cnt=100 ; __cnt--;) {
          switch (__pc) {
          case 0:
            //$LASTPOS=9000765;//user.Turtle:765
            if (!(_this.autoDraw)) { __pc=2     ; break; }
            //$LASTPOS=9000789;//user.Turtle:789
            _this.fiber$enter(_thread, (function anonymous_794() {
              
              //$LASTPOS=9000809;//user.Turtle:809
              _this.context.beginPath();
              //$LASTPOS=9000842;//user.Turtle:842
              _this.context.moveTo(_this.px,_this.py);
              //$LASTPOS=9000877;//user.Turtle:877
              _this.context.lineTo(x,y);
              //$LASTPOS=9000910;//user.Turtle:910
              _this.context.closePath();
              //$LASTPOS=9000943;//user.Turtle:943
              _this.fillAndStroke();
            }));
            __pc=1;return;
          case 1:
            
            __pc=3     ;break;
          case 2     :
            {
              //$LASTPOS=9000992;//user.Turtle:992
              _this.context.lineTo(x,y);
            }
          case 3     :
            
            //$LASTPOS=9001023;//user.Turtle:1023
            _this.px=x;
            //$LASTPOS=9001028;//user.Turtle:1028
            _this.py=y;
            _thread.exit(_this);return;
          }
        }
      });
    },
    circle :function _trc_Turtle_circle(r) {
      "use strict";
      var _this=this;
      
      //$LASTPOS=9001053;//user.Turtle:1053
      _this.enter((function anonymous_1058() {
        
        //$LASTPOS=9001069;//user.Turtle:1069
        _this.context.beginPath();
        //$LASTPOS=9001098;//user.Turtle:1098
        _this.context.arc(_this.x,_this.y,r,0,Tonyu.globals.$Math.PI*2);
        //$LASTPOS=9001139;//user.Turtle:1139
        _this.context.closePath();
        //$LASTPOS=9001168;//user.Turtle:1168
        _this.fillAndStroke();
      }));
    },
    fiber$circle :function _trc_Turtle_f_circle(_thread,r) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      
      
      _thread.enter(function _trc_Turtle_ent_circle(_thread) {
        if (_thread.lastEx) __pc=_thread.catchPC;
        for(var __cnt=100 ; __cnt--;) {
          switch (__pc) {
          case 0:
            //$LASTPOS=9001053;//user.Turtle:1053
            _this.fiber$enter(_thread, (function anonymous_1058() {
              
              //$LASTPOS=9001069;//user.Turtle:1069
              _this.context.beginPath();
              //$LASTPOS=9001098;//user.Turtle:1098
              _this.context.arc(_this.x,_this.y,r,0,Tonyu.globals.$Math.PI*2);
              //$LASTPOS=9001139;//user.Turtle:1139
              _this.context.closePath();
              //$LASTPOS=9001168;//user.Turtle:1168
              _this.fillAndStroke();
            }));
            __pc=1;return;
          case 1:
            
            _thread.exit(_this);return;
          }
        }
      });
    },
    fillAndStroke :function _trc_Turtle_fillAndStroke() {
      "use strict";
      var _this=this;
      
      //$LASTPOS=9001217;//user.Turtle:1217
      if (_this.doFill) {
        //$LASTPOS=9001229;//user.Turtle:1229
        _this.context.fill();
      }
      //$LASTPOS=9001249;//user.Turtle:1249
      if (_this.doStroke) {
        //$LASTPOS=9001263;//user.Turtle:1263
        _this.context.stroke();
      }
    },
    fiber$fillAndStroke :function _trc_Turtle_f_fillAndStroke(_thread) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      
      //$LASTPOS=9001217;//user.Turtle:1217
      if (_this.doFill) {
        //$LASTPOS=9001229;//user.Turtle:1229
        _this.context.fill();
      }
      //$LASTPOS=9001249;//user.Turtle:1249
      if (_this.doStroke) {
        //$LASTPOS=9001263;//user.Turtle:1263
        _this.context.stroke();
      }
      
      _thread.retVal=_this;return;
    },
    enter :function _trc_Turtle_enter(f) {
      "use strict";
      var _this=this;
      var ee;
      var e;
      
      //$LASTPOS=9001299;//user.Turtle:1299
      _this.context.save();
      
      try {
        //$LASTPOS=9001345;//user.Turtle:1345
        f();
        
      } catch (e) {
        //$LASTPOS=9001375;//user.Turtle:1375
        ee=e;
        
      }
      //$LASTPOS=9001391;//user.Turtle:1391
      _this.context.restore();
      //$LASTPOS=9001414;//user.Turtle:1414
      if (ee) {
        throw ee;
        
      }
    },
    fiber$enter :function _trc_Turtle_f_enter(_thread,f) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      var ee;
      var e;
      
      //$LASTPOS=9001299;//user.Turtle:1299
      _this.context.save();
      
      try {
        //$LASTPOS=9001345;//user.Turtle:1345
        f();
        
      } catch (e) {
        //$LASTPOS=9001375;//user.Turtle:1375
        ee=e;
        
      }
      //$LASTPOS=9001391;//user.Turtle:1391
      _this.context.restore();
      //$LASTPOS=9001414;//user.Turtle:1414
      if (ee) {
        throw ee;
        
      }
      
      _thread.retVal=_this;return;
    },
    __dummy: false
  },
  decls: {"methods":{"main":{"nowait":false},"new":{"nowait":false},"__setter__lineWidth":{"nowait":true},"__setter__fillStyle":{"nowait":true},"__setter__strokeStyle":{"nowait":true},"beginPath":{"nowait":false},"closePath":{"nowait":false},"rotate":{"nowait":false},"forward":{"nowait":false},"moveTo":{"nowait":false},"lineTo":{"nowait":false},"circle":{"nowait":false},"fillAndStroke":{"nowait":false},"enter":{"nowait":false}},"fields":{"context":{},"px":{},"py":{},"dir":{},"autoDraw":{},"doFill":{},"doStroke":{}}}
});

//# sourceMappingURL=concat.js.map